=== src/plugins/CMakeLists.txt ===
# override default path where built files are put to allow running qgis without installing
SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${QGIS_OUTPUT_DIRECTORY}/${QGIS_PLUGIN_SUBDIR})
SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${QGIS_OUTPUT_DIRECTORY}/${QGIS_PLUGIN_SUBDIR})

ADD_SUBDIRECTORY(interpolation)
ADD_SUBDIRECTORY(oracle_raster)
ADD_SUBDIRECTORY(raster_terrain_analysis)
ADD_SUBDIRECTORY(coordinate_capture)
ADD_SUBDIRECTORY(dxf2shp_converter)
ADD_SUBDIRECTORY(evis)
ADD_SUBDIRECTORY(spatialquery)
ADD_SUBDIRECTORY(sqlanywhere)
ADD_SUBDIRECTORY(roadgraph)
ADD_SUBDIRECTORY(zonal_statistics)
ADD_SUBDIRECTORY(georeferencer)
ADD_SUBDIRECTORY(gps_importer)
ADD_SUBDIRECTORY(topology)
ADD_SUBDIRECTORY(offline_editing)
ADD_SUBDIRECTORY(heatmap)

IF (POSTGRES_FOUND)
  ADD_SUBDIRECTORY(spit)
ENDIF (POSTGRES_FOUND)

IF (GRASS_FOUND)
  IF (GRASS_MAJOR_VERSION LESS 7 )
    ADD_SUBDIRECTORY(grass)
  ENDIF (GRASS_MAJOR_VERSION LESS 7 )
ENDIF (GRASS_FOUND)

IF (WITH_GLOBE)
  ADD_SUBDIRECTORY(globe)
ENDIF (WITH_GLOBE)

IF (CUSTOM_PLUGINS)
  ADD_SUBDIRECTORY(${CUSTOM_PLUGINS})
ENDIF (CUSTOM_PLUGINS)

IF (QT_MOBILITY_SENSORS_FOUND)
  ADD_SUBDIRECTORY(compass)
ENDIF (QT_MOBILITY_SENSORS_FOUND)

# headers installed in qgis_core target
