=== debian/changelog ===
qgis (2.4.0-1ubuntu2) vivid; urgency=medium

  * No-change rebuild for the libgdal-dev 1.11.2 transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 18 Mar 2015 01:06:26 -0600

qgis (2.4.0-1ubuntu1) vivid; urgency=medium

  * debian/patches/make-qwtpolar-optional.patch
    debian/patches/fix-build-without-qwtpolar.patch:
    - Fix building without QWT since Ubuntu has too new version
      (LP: #1423906)
    - Rebase to apply on top of 2.4.0
  * debian/rules: build with DWITH_QWTPOLAR=OFF

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 20 Feb 2015 14:49:00 +0000

qgis (2.4.0-1) unstable; urgency=medium

  * Add patches from upstream release-2_4 branch.
  * Batchpatch symbols files for non-amd64 architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Tue, 30 Sep 2014 21:06:48 +0200

qgis (2.4.0-1~exp2) experimental; urgency=medium

  * Team upload.
  * Apply patch to fix qreal issue for arm*
    Thanks to Peter Green (Closes: #760535)
  * Add .pc quilt dir to .gitignore
  * Fix description-is-pkg-name lintian error
  * Fix wildcard-matches-nothing lintian error in copyright file

 -- Ross Gammon <rossgammon@mail.dk>  Wed, 10 Sep 2014 20:33:47 +0200

qgis (2.4.0-1~exp1) experimental; urgency=medium

  [ Jürgen E. Fischer ]
  * Release of 2.4

  [ Bas Couwenberg ]
  * New upstream release.
  * Drop obsolete patches, refresh remaining patches.
  * Don't install libgrass_gis, no longer built.
  * Remove unused template files, used by upstream packaging only.
  * Remove extra license file.
  * Exclude libqgis-customwidgets2.4.0 from dh_makeshlibs.
  * Update lintian overrides for 2.4.0.
  * Remove duplicate -f, $(RM) already uses it.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Sun, 06 Jul 2014 00:58:34 +0200

qgis (2.3.0) UNRELEASED; urgency=medium

  * New development version 2.3 after branch of 2.2
  * enable globe on jessie
  * add dependency on libqt4-sql-sqlite to qgis-provider
  * merge debian packageing changes
  * merge distribution specific file templates into one file template
  * include metasearch plugins and add it's dependencies
  * include custom widgets

 -- Jürgen E. Fischer <jef@norbit.de>  Fri, 27 Jun 2014 14:00:08 +0200

qgis (2.2.0) UNRELEASED; urgency=medium

  * Release of 2.2

 -- Jürgen E. Fischer <jef@norbit.de>  Sat, 22 Feb 2014 09:49:29 +0100
